#ifndef _EXPORT_FUNC_H_
#define _EXPORT_FUNC_H_


//return successful result
#define  LIB_SUCCESS      0  
//return failed result
#define  LIB_FAILED       1

#define  MAX_RF_BUFFER    1024

//ϵͳ
int WINAPI lib_ver(unsigned int *pVer);
int WINAPI rf_init_com(int port,long baud);
int WINAPI rf_ClosePort();
int WINAPI rf_get_model(unsigned short icdev, unsigned char *pVersion, unsigned char *pLen);
int WINAPI rf_init_device_number(unsigned short icdev);
int WINAPI rf_get_device_number(unsigned short *Icdev);
int WINAPI rf_light(unsigned short icdev,unsigned char color);
int WINAPI rf_beep(unsigned short icdev,unsigned char msec);
int WINAPI rf_init_type(unsigned short icdev,unsigned char type);
int WINAPI rf_antenna_sta(unsigned short icdev, unsigned char mode);

//DES
int WINAPI des_encrypt(unsigned char *szOut,unsigned char *szIn , unsigned int inlen,unsigned char *key,unsigned int keylen);
int WINAPI des_decrypt(unsigned char *szOut,unsigned char *szIn , unsigned int inlen,unsigned char *key,unsigned int keylen);


//SAM
int WINAPI rf_init_sam(unsigned short icdev,unsigned char bound);
int WINAPI rf_sam_rst(unsigned short icdev, unsigned char *pData,unsigned char* pMsgLg);
int WINAPI rf_sam_cos(unsigned short icdev, unsigned char *command,unsigned char cmdLen ,unsigned char *pData,unsigned char* Length);

//ISO14443A
int WINAPI rf_request(unsigned short icdev, unsigned char mode, unsigned short *pTagType);
int WINAPI rf_anticoll(unsigned short icdev, unsigned char bcnt, unsigned char *pSnr,unsigned char *pLen);
int WINAPI rf_select(unsigned short icdev,unsigned char *pSnr,unsigned char srcLen,unsigned char *pSize);
int WINAPI rf_halt(unsigned short icdev);
int WINAPI rf_M1_authentication2(unsigned short icdev,unsigned char mode,unsigned char secnr,unsigned char *pKey);
int WINAPI rf_M1_read(unsigned short icdev, unsigned char block, unsigned char *pData,unsigned char* pLen);
int WINAPI rf_M1_write(unsigned short icdev, unsigned char block, unsigned char *pData);
int WINAPI rf_M1_initval(unsigned short icdev, unsigned char block, long value);
int WINAPI rf_M1_readval(unsigned short icdev, unsigned char block,long* pValue);
int WINAPI rf_M1_decrement(unsigned short icdev, unsigned char block,long value);
int WINAPI rf_M1_increment(unsigned short icdev, unsigned char block,long value);
int WINAPI rf_M1_restore(unsigned short icdev, unsigned char block);
int WINAPI rf_M1_transfer(unsigned short icdev, unsigned char block);
int WINAPI rf_ul_select(unsigned short icdev, unsigned char *pSnr,unsigned char *pLen);
int WINAPI rf_ul_write(unsigned short icdev, unsigned char page, unsigned char *data);
int WINAPI rf_Shc1102_Auth(unsigned short icdev, unsigned char *pPassunsigned short) ;
int WINAPI rf_Shc1102_Read(unsigned short icdev, unsigned char block, unsigned char *pData,unsigned char *pLen) ;
int WINAPI rf_Shc1102_Write(unsigned short icdev, unsigned char block, unsigned char *pData) ;
int WINAPI rf_typea_rst(unsigned short icdev,unsigned char model,unsigned char *pData,unsigned char* pMsgLg);
int WINAPI rf_cos_command(unsigned short icdev, unsigned char *command,unsigned char cmdLen,unsigned char *pData,unsigned char* pMsgLg);
int WINAPI rf_cl_deselect(unsigned short icdev);


//ISO14443B
int WINAPI rf_at020_check(unsigned short icdev, unsigned char *pKey);
int WINAPI rf_at020_read(unsigned short icdev, unsigned char adr, unsigned char *pData,unsigned char* pMsgLen); 
int WINAPI rf_at020_write(unsigned short icdev, unsigned char adr, unsigned char *pData); 
int WINAPI rf_at020_lock(unsigned short icdev,unsigned char *pData);
int WINAPI rf_at020_count(unsigned short icdev,unsigned char *pData);
int WINAPI rf_at020_deselect(unsigned short icdev);

int WINAPI rf_st_select(unsigned short icdev, unsigned char* pChip_ID);
int WINAPI rf_sr176_readblock(unsigned short icdev, unsigned char block, unsigned char *pData,unsigned char *pLen);
int WINAPI rf_sr176_writeblock(unsigned short icdev, unsigned char block, unsigned char *pData);
int WINAPI rf_sr176_protectblock(unsigned short icdev, unsigned char lockreg);
int WINAPI rf_srix4k_getuid(unsigned short icdev, unsigned char *pUid, unsigned char *pLen);
int WINAPI rf_srix4k_readblock(unsigned short icdev, unsigned char block, unsigned char *pData,unsigned char *pLen);
int WINAPI rf_srix4k_writeblock(unsigned short icdev, unsigned char block, unsigned char *pData);
int WINAPI rf_srix4k_writelockreg(unsigned short icdev, unsigned char lockreg);
int WINAPI rf_st_completion(unsigned short icdev);

int WINAPI rf_atqb(unsigned short icdev,unsigned char model,unsigned char *pData,unsigned char *pMsgLg);
int WINAPI rf_typeb_cos(unsigned short icdev, unsigned char CID,unsigned char *command, unsigned char cmdLen,unsigned char *pData,unsigned char *pMsgLg);
//int WINAPI rf_cl_deselect(unsigned short icdev);


//ISO15693
int WINAPI ISO15693_Inventory(unsigned short icdev, unsigned char *pData, unsigned char *pLen);
int WINAPI ISO15693_Stay_Quiet(unsigned short icdev, unsigned char *pUID);
int WINAPI ISO15693_Select(unsigned short icdev, unsigned char *pUID);
int WINAPI ISO15693_Reset_To_Ready(unsigned short icdev, unsigned char model, unsigned char *pUID);
int WINAPI ISO15693_Read(unsigned short icdev, unsigned char model, unsigned char *pUID, unsigned char block, unsigned char number,unsigned char *pData, unsigned char *pLen);
int WINAPI ISO15693_Write(unsigned short icdev, unsigned char model, unsigned char *pUID, unsigned char block,unsigned char *pData);
int WINAPI ISO15693_Lock_Block(unsigned short icdev, unsigned char model, unsigned char *pUID, unsigned char block);
int WINAPI ISO15693_Write_AFI(unsigned short icdev, unsigned char model, unsigned char *pUID, unsigned char AFI);
int WINAPI ISO15693_Lock_AFI(unsigned short icdev, unsigned char model, unsigned char *pUID);
int WINAPI ISO15693_Write_DSFID(unsigned short icdev, unsigned char model, unsigned char *pUID, unsigned char DSFID);
int WINAPI ISO15693_Lock_DSFID(unsigned short icdev, unsigned char model, unsigned char *pUID);
int WINAPI ISO15693_Get_System_Information(unsigned short icdev, unsigned char model, unsigned char *pUID, unsigned char *pData, unsigned char *pLen);
int WINAPI ISO15693_Get_Block_Security(unsigned short icdev, unsigned char model,unsigned char *pUID,unsigned char block,unsigned char number, unsigned char *pData,unsigned char *pLen);
                                           


int WINAPI smartcard_rst(unsigned short icdev, unsigned char *pData,unsigned char *pMsgLg);
int WINAPI smartcard_cos(unsigned short icdev, unsigned char *pCommand, unsigned char cmdLen, unsigned char *pData, unsigned char *pMsgLg);
int WINAPI AT24_read(unsigned short icdev,  unsigned short offset,unsigned char *pData,unsigned short len);
int WINAPI AT24_write(unsigned short icdev,  unsigned short offset,unsigned char *pData,unsigned short len);
int WINAPI AT1608_Rst(unsigned short icdev,unsigned char* pData);
int WINAPI AT1608_Authenticate(unsigned short icdev, unsigned char *pQ0, unsigned char *pQ1);
int WINAPI AT1608_VerifyPassword(unsigned short icdev,  unsigned char index,  unsigned char *pPassword);
int WINAPI AT1608_Read(unsigned short icdev, unsigned char addr, unsigned short len, unsigned char zone, unsigned char *pData);
int WINAPI AT1608_Write(unsigned short icdev, unsigned char addr, unsigned char zone, unsigned char *pData, unsigned short len);
int WINAPI AT1608_ReadFuse(unsigned short icdev,  unsigned char *pFuse);
int WINAPI AT1608_WriteFuse(unsigned short icdev);

int WINAPI OpenCard(unsigned short icdev);
int WINAPI CloseCard(unsigned short icdev);
int WINAPI AutoTestCard(unsigned short icdev,  unsigned char *pData);


#endif